Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanImprovementOperator.cs	(revision 7786)
@@ -29,5 +29,4 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.Knapsack;
 using HeuristicLab.Problems.TravelingSalesman;
 
@@ -38,47 +37,24 @@
   [Item("TravelingSalesmanImprovementOperator", "An operator that improves traveling salesman solutions.")]
   [StorableClass]
-  public sealed class TravelingSalesmanImprovementOperator : SingleSuccessorOperator, ILocalImprovementOperator, IScatterSearchTargetProcessor {
-    #region Problem properties
-    public Type ProblemType {
-      get { return typeof(KnapsackProblem); }
-    }
-    [Storable]
-    private KnapsackProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-      set { problem = (KnapsackProblem)value; }
-    }
-    #endregion
-
+  public sealed class TravelingSalesmanImprovementOperator : SingleSuccessorOperator, IImprovementOperator {
     #region Parameter properties
     public ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
-    public IValueLookupParameter<DoubleMatrix> CoordinatesParameter {
-      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Coordinates"]; }
+    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
+      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
     }
-    public IValueLookupParameter<IEvaluator> EvaluatorParameter {
-      get { return (IValueLookupParameter<IEvaluator>)Parameters["Evaluator"]; }
+    public ILookupParameter<IEvaluator> EvaluatorParameter {
+      get { return (ILookupParameter<IEvaluator>)Parameters["Evaluator"]; }
     }
-    public IValueLookupParameter<IntValue> ImprovementAttemptsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["ImprovementAttempts"]; }
+    public IValueParameter<IntValue> ImprovementAttemptsParameter {
+      get { return (IValueParameter<IntValue>)Parameters["ImprovementAttempts"]; }
     }
-    public IValueLookupParameter<IRandom> RandomParameter {
-      get { return (IValueLookupParameter<IRandom>)Parameters["Random"]; }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
     }
     public IValueLookupParameter<IItem> TargetParameter {
       get { return (IValueLookupParameter<IItem>)Parameters["Target"]; }
     }
-    #region ILocalImprovementOperator Parameters
-    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
-    public ILookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    public ILookupParameter<ResultCollection> ResultsParameter {
-      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
-    }
-    #endregion
     #endregion
 
@@ -87,7 +63,7 @@
       get { return CurrentScopeParameter.ActualValue; }
     }
-    public DoubleMatrix Coordinates {
-      get { return CoordinatesParameter.ActualValue; }
-      set { CoordinatesParameter.ActualValue = value; }
+    public DistanceMatrix DistanceMatrix {
+      get { return DistanceMatrixParameter.ActualValue; }
+      set { DistanceMatrixParameter.ActualValue = value; }
     }
     public IEvaluator Evaluator {
@@ -96,6 +72,6 @@
     }
     public IntValue ImprovementAttempts {
-      get { return ImprovementAttemptsParameter.ActualValue; }
-      set { ImprovementAttemptsParameter.ActualValue = value; }
+      get { return ImprovementAttemptsParameter.Value; }
+      set { ImprovementAttemptsParameter.Value = value; }
     }
     public IRandom Random {
@@ -110,16 +86,13 @@
     [StorableConstructor]
     private TravelingSalesmanImprovementOperator(bool deserializing) : base(deserializing) { }
-    private TravelingSalesmanImprovementOperator(TravelingSalesmanImprovementOperator original, Cloner cloner)
-      : base(original, cloner) {
-      this.problem = cloner.Clone(original.problem);
-    }
+    private TravelingSalesmanImprovementOperator(TravelingSalesmanImprovementOperator original, Cloner cloner) : base(original, cloner) { }
     public TravelingSalesmanImprovementOperator()
       : base() {
       #region Create parameters
       Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Coordinates"));
-      Parameters.Add(new ValueLookupParameter<IEvaluator>("Evaluator"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("ImprovementAttempts", new IntValue(100)));
-      Parameters.Add(new ValueLookupParameter<IRandom>("Random"));
+      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix"));
+      Parameters.Add(new LookupParameter<IEvaluator>("Evaluator"));
+      Parameters.Add(new ValueParameter<IntValue>("ImprovementAttempts", new IntValue(100)));
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
       Parameters.Add(new ValueLookupParameter<IItem>("Target"));
       #endregion
@@ -132,22 +105,18 @@
 
     public override IOperation Apply() {
-      var currSol = CurrentScope.Variables[TargetParameter.ActualName].Value as Permutation;
-      var bestSol = currSol;
-      double currLength = TSPEuclideanPathEvaluator.Apply(Evaluator as TSPCoordinatesPathEvaluator, Coordinates, currSol);
-      double bestLength = currLength;
+      Permutation currSol = CurrentScope.Variables[TargetParameter.ActualName].Value as Permutation;
+      if (currSol.PermutationType != PermutationTypes.RelativeUndirected)
+        throw new ArgumentException("Cannot improve solution because the permutation type is not supported.");
 
       for (int i = 0; i < ImprovementAttempts.Value; i++) {
         int a = Random.Next(currSol.Length);
         int b = Random.Next(currSol.Length);
-        Invert(currSol, a, b);
-        currLength = TSPEuclideanPathEvaluator.Apply(Evaluator as TSPCoordinatesPathEvaluator, Coordinates, currSol);
-        if (currLength < bestLength) {
-          bestLength = currLength;
-          bestSol = currSol.Clone() as Permutation;
-        }
-        Invert(currSol, a, b);
+        double oldFirstEdgeLength = DistanceMatrix[currSol[a], currSol[(a - 1 + currSol.Length) % currSol.Length]];
+        double oldSecondEdgeLength = DistanceMatrix[currSol[b], currSol[(b + 1) % currSol.Length]];
+        double newFirstEdgeLength = DistanceMatrix[currSol[b], currSol[(a - 1 + currSol.Length) % currSol.Length]];
+        double newSecondEdgeLength = DistanceMatrix[currSol[a], currSol[(b + 1 + currSol.Length) % currSol.Length]];
+        if (newFirstEdgeLength + newSecondEdgeLength < oldFirstEdgeLength + oldSecondEdgeLength)
+          Invert(currSol, a, b);
       }
-
-      CurrentScope.Variables[TargetParameter.ActualName].Value = bestSol;
 
       return base.Apply();
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanMultipleGuidesPathRelinker.cs	(revision 7786)
@@ -72,6 +72,6 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var v1 = initiator.Clone() as Permutation;
-      var targets = new Permutation[guides.Length];
+      Permutation v1 = initiator.Clone() as Permutation;
+      Permutation[] targets = new Permutation[guides.Length];
       Array.Copy(guides, targets, guides.Length);
 
@@ -79,13 +79,13 @@
         throw new ArgumentException("At least one solution is of different length.");
 
-      var solutions = new List<Permutation>();
+      IList<Permutation> solutions = new List<Permutation>();
       for (int i = 0; i < v1.Length; i++) {
-        var currCityIndex = i;
-        var bestCityIndex = (i + 1) % v1.Length;
-        var currDistance = distances[v1[currCityIndex], v1[bestCityIndex]];
+        int currCityIndex = i;
+        int bestCityIndex = (i + 1) % v1.Length;
+        double currDistance = distances[v1[currCityIndex], v1[bestCityIndex]];
         targets.ToList().ForEach(solution => {
           var node = solution.Select((x, index) => new { Id = x, Index = index }).First(x => x.Id == v1[currCityIndex]);
-          var pred = solution[(node.Index - 1 + solution.Length) % solution.Length];
-          var succ = solution[(node.Index + 1) % solution.Length];
+          int pred = solution[(node.Index - 1 + solution.Length) % solution.Length];
+          int succ = solution[(node.Index + 1) % solution.Length];
           var results = new[] { pred, succ }.Select(x => new { Id = x, Distance = distances[x, node.Id] });
           if (results.Any(x => x.Distance < currDistance)) {
@@ -99,11 +99,11 @@
       }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanPathRelinker.cs	(revision 7786)
@@ -54,11 +54,11 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var v1 = initiator.Clone() as Permutation;
-      var v2 = guide as Permutation;
+      Permutation v1 = initiator.Clone() as Permutation;
+      Permutation v2 = guide as Permutation;
 
       if (v1.Length != v2.Length)
         throw new ArgumentException("The solutions are of different length.");
 
-      var solutions = new List<Permutation>();
+      IList<Permutation> solutions = new List<Permutation>();
       for (int i = 0; i < v1.Length; i++)
         if (v1[i] != v2[i]) {
@@ -73,11 +73,11 @@
         }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimilarityCalculator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimilarityCalculator.cs	(revision 7786)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimilarityCalculator.cs	(revision 7786)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.TravelingSalesman {
+  /// <summary>
+  /// An operator that performs similarity calculation between two traveling salesman solutions.
+  /// </summary>
+  [Item("TravelingSalesmanSimilarityCalculator", "An operator that performs similarity calculation between two traveling salesman solutions.")]
+  [StorableClass]
+  public sealed class TravelingSalesmanSimilarityCalculator : SimilarityCalculator {
+    [StorableConstructor]
+    private TravelingSalesmanSimilarityCalculator(bool deserializing) : base(deserializing) { }
+    private TravelingSalesmanSimilarityCalculator(TravelingSalesmanSimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public TravelingSalesmanSimilarityCalculator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TravelingSalesmanSimilarityCalculator(this, cloner);
+    }
+
+    protected override double CalculateDiversity(IScope left, IScope right) {
+      Permutation v1 = left.Variables["TSPTour"].Value as Permutation;
+      Permutation v2 = right.Variables["TSPTour"].Value as Permutation;
+
+      int[,] edges = new int[v2.Length, 2];
+      for (int i = 0; i < v2.Length; i++) {
+        edges[v2[i], 0] = v2[(i + 1) % v2.Length];
+        edges[v2[i], 1] = v2[(i - 1 + v2.Length) % v2.Length];
+      }
+
+      double similarity = 0.0;
+      for (int i = 0; i < v1.Length; i++) {
+        int targetCity = v1[(i + 1) % v1.Length];
+        if (targetCity == edges[v1[i], 0] || targetCity == edges[v1[i], 1])
+          similarity++;
+      }
+
+      return similarity / v1.Length;
+    }
+  }
+}
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/TravelingSalesman/TravelingSalesmanSimultaneousPathRelinker.cs	(revision 7786)
@@ -54,13 +54,13 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var firstInitiator = initiator.Clone() as Permutation;
-      var firstGuide = guide.Clone() as Permutation;
-      var secondInitiator = firstGuide.Clone() as Permutation;
-      var secondGuide = firstInitiator.Clone() as Permutation;
+      Permutation firstInitiator = initiator.Clone() as Permutation;
+      Permutation firstGuide = guide.Clone() as Permutation;
+      Permutation secondInitiator = firstGuide.Clone() as Permutation;
+      Permutation secondGuide = firstInitiator.Clone() as Permutation;
 
       if (firstInitiator.Length != firstGuide.Length)
         throw new ArgumentException("The solutions are of different length.");
 
-      var solutions = new List<Permutation>();
+      IList<Permutation> solutions = new List<Permutation>();
       for (int i = 0; i < firstInitiator.Length / 2; i++) {
         if (firstInitiator[i] != firstGuide[i]) {
@@ -72,5 +72,5 @@
           solutions.Add(firstInitiator.Clone() as Permutation);
         }
-        var j = secondInitiator.Length - 1 - i;
+        int j = secondInitiator.Length - 1 - i;
         if (secondInitiator[j] != secondGuide[j]) {
           var target = secondInitiator.Select((x, index) => new { Value = x, ValueIndex = index }).First(x => x.Value == secondGuide[j]);
@@ -83,11 +83,11 @@
       }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
